//#include "libhfs/hfs.h"
//#include "libhfs/apple.h"
#include "libhfs/libhfs.h"
#include "libhfs/medium.h"
#include <stdio.h>
#include <errno.h>
#include <sys/stat.h>

#define BLOCKSIZE 512



int main(int argc, char **argv)
{
	int err;
	char buff[2];
	struct stat st;
	long psize; /* in blocks */
	hfsvol vol;
	
	if (argc < 2) {
		printf("%s device|imagefile\n", argv[0]);
		return 1;
	}
	if (stat(argv[1], &st) < 0) {
		fprintf(stderr, "error stating %s: 0x%08lx\n", argv[1], errno);
		return 1;
	}
	psize = (long)(st.st_size / BLOCKSIZE);
	psize -= 10; // remove the room the part map takes ?
	printf("format %ld blocks on %s, are you sure ?\n", psize, argv[1]);
	if (read(0, buff, 1) < 1)
		return 1;
	if (buff[0] != 'y')
		return 1;
	
	v_init(&vol, HFS_OPT_NOCACHE);
	if (v_open(&vol, argv[1], HFS_MODE_RDWR) == -1) {
		printf("v_open() = 0x%08lx\n", errno);
		return 1;
	}
	err = m_zeropm(&vol, 4);
	if (err < 0) {
		printf("zeropm() = 0x%08lx, 0x%08lx\n", err, errno);
		return 1;
	}
	if (m_mkpart(&vol, "MacOS", "Apple_HFS", psize) == -1) {
		printf("mkpart() = -1, 0x%08lx\n", errno);
	}
	if (v_close(&vol) == -1) {
		printf("v_close() = 0x%08lx\n", errno);
		return 1;
	}
/*
	err = hfs_mkpart(argv[1], psize);
	if (err < 0) {
		printf("mkpart() = 0x%08lx, 0x%08lx\n", err, errno);
		return 1;
	}
*/
/*
int hfs_format(const void *devicehandle, int pnum, int mode, const char *vname,
               unsigned int nbadblocks, const unsigned long badblocks[])
*/
	err = hfs_format(argv[1], 1, HFS_MODE_RDWR, "MacOS", 0, NULL);
	printf("format() = 0x%08lx\n", err);
	return 0;
}

